일반

Q: Amazon Corretto란 무엇인가요?

Corretto는 Amazon의 장기적 지원을 받는 Open Java Development Kit(OpenJDK)의 빌드입니다. Corretto는 Java Technology Compatibility Kit(TCK)를 사용하여 Java SE 표준을 충족하고 Linux, Windows 및 macOS에서 사용할 수 있도록 인증을 받았습니다.

Q: Corretto를 사용해야 하는 이유는 무엇인가요?

Corretto는 OpenJDK의 신뢰할 수 있는 빌드로서 장기적인 무료 지원이 보장됩니다. Amazon은 내부적으로 수천 개의 프로덕션 서비스에서 Corretto를 실행합니다. Corretto에 대한 수정 사항을 만들 때마다 OpenJDK를 실행하면서 발견된 문제를 수정하거나 완화할 수 있습니다. 또한 Amazon은 주기적인 분기별 적용 시점이 아닌 시점에도 긴급 수정 사항(보안 포함)이 제공되어 사용할 준비가 되면 적용할 계획입니다.

Q: Corretto는 OpenJDK와 어떻게 다른가요?

Corretto는 해당 OpenJDK 업데이트 프로젝트에 아직 통합되지 않은 Amazon에서 제공하는 패치가 포함된 Open JDK 배포판입니다. Amazon은 대규모 서비스를 실행하면서 Amazon이 관찰한 결과를 기준으로 선택한, OpenJDK의 성능 또는 안정성을 개선하는 패치에 중점을 두고 있습니다.

Q: Amazon은 Corretto에 어떤 종류의 패치를 포함할 계획인가요?

패치에는 보안 수정, 성능 향상(예: 자주 사용하는 함수의 속도 개선), 가비지 수집 예약 및 메모리 부족 상황 방지와 모니터링, 보고 및 임계값 관리 개선 등이 포함됩니다.

Q: Corretto 사용과 관련한 비용이 있나요?

Corretto는 오픈 소스 라이선스에 따라 Amazon에서 무료로 배포합니다. 클래스 경로 예외(CPE 포함 GPLv2)와 함께 GNU 퍼블릭 라이선스 버전 2의 약관에 따라 라이선스가 부여됩니다. Amazon은 사용 또는 배포 비용을 청구하지 않습니다.

Q: Corretto에서 장기 지원(LTS)이란 무엇을 의미하나요?

Amazon Corretto는 무료로 사용할 수 있는 Open Java Development Kit(OpenJDK)의 프로덕션용 멀티플랫폼 배포판으로, 장기 지원(LTS)이 함께 제공됩니다. LTS에는 관련 릴리스 버전에 대해 최소한 지정된 날짜(예: Corretto 8의 경우 2026년 5월)까지 성능 개선 및 보안 업데이트를 무료로 제공하겠다는 Amazon의 약속이 포함되어 있습니다. 업데이트는 분기별로 릴리스될 예정입니다. 또한 Amazon은 주기적인 분기별 적용 시점이 아닌 시점에도 긴급 수정 사항(보안 포함)이 제공되어 사용할 준비가 되면 적용할 계획입니다.

Q: Corretto의 장기 지원에는 무엇이 포함되나요?

Corretto에 대한 장기 지원(LTS)에는 수명이 다할 때까지 무료 성능 향상 및 보안 업데이트가 포함됩니다. 업데이트는 분기별로 릴리스될 예정입니다.

Corretto의 LTS는 AWS에서 목표를 달성하기 위한 전문가 지침 및 지원을 제공하는 AWS Support 플랜과 관련이 없습니다. 이미 AWS Support 플랜에 가입한 경우, 지원되는 다른 모든 AWS 서비스 및 소프트웨어와 동일한 기준으로 Corretto에도 지원이 제공됩니다. 플랜에 가입하지 않은 사용자의 경우, 단순히 Corretto에 대한 지원을 받기 위해 플랜을 구매하는 것은 합리적일 수도 있고 그렇지 않을 수도 있습니다. Amazon Support 웹 사이트를 방문하여 본인에게 적합한지 확인하세요. 현재로서는 Corretto 전용 지원 플랜을 제공할 계획이 없습니다. 항상 그렇듯이 로드맵은 고객 피드백을 반영한 것이며, Corretto GitHub 리포지토리에서 언제든 기능을 요청하실 수 있습니다.
 

Q: Corretto의 지원 일정은 어떻게 되나요?

         
Coretto 릴리스 릴리스 유형 GA 날짜
마지막으로 계획된 업데이트 지원 종료
21 LTS 2023년 9월 21일 2030년 7월 2030년 10월
17 LTS 2021년 9월 16일 2029년 7월 2029년 10월
11 LTS 2019년 3월 15일 2027년 7월 2027년 10월
8 LTS 2019년 1월 31일
2026년 4월 2026년 7월

 

LTS: 장기 지원

Q: Corretto와 관련하여 도움이 필요하면 어떻게 해야 하나요?

Corretto 설치 또는 실행에 대한 일반적인 질문은 설명서를 참조하세요. OpenJDK와 관련하여 문제가 있는 경우 업스트림 OpenJDK 프로젝트에서 이슈를 개설하세요. Corretto와 관련하여 특정한 문제가 있거나 OpenJDK에 해당되지 않는 기능 요청이 있는 경우 Corretto GitHub 리포지토리에서 이슈 또는 기능 요청을 개설하세요. 이미 AWS Support 플랜을 보유한 경우 플랜을 통해 Corretto에 대한 지원을 요청하실 수 있습니다.
 

Amazon Corretto 사용

Q: Corretto를 다른 JDK의 드롭인 대체 솔루션으로 사용할 수 있나요?

Corretto는 OpenJDK에서 사용할 수 없는 기능을 사용하지 않는 한 모든 Java SE 배포판을 드롭인 방식으로 대체하도록 설계되었습니다. Corretto 바이너리가 호스트에 설치되고 Java 애플리케이션을 실행하기 위해 올바르게 간접적으로 호출되면(예: Linux의 대체 명령 사용) 기존 명령줄 옵션, 조정 파라미터, 모니터링 및 기타 모든 기능이 이전과 같이 계속 작동합니다.

Q: Corretto에는 JavaFX가 포함되어 있나요? 그렇다면 Corretto의 어떤 버전에 번들로 포함되어 있나요?

OpenJDK 11 이전에는 JavaFX가 OpenJDK에 포함되어 있었습니다. 하지만 2018년에 Oracle은 JavaFX를 OpenJDK에서 분리하여 OpenJDK 배포판에서 제거했습니다. Corretto 8에는 다음 플랫폼을 위한 JavaFX가 포함되어 있습니다.

AL2 x64
Generic Linux x64
Windows x86 JDK
Windows x64 JDK
Windows x86 JRE
Windows x64 JRE

버전에 관계없이 다른 플랫폼에는 포함하지 않습니다. 예를 들어 Mac M1용 Corretto 8에서는 JavaFX가 지원되지 않습니다.

Corretto 17 이상으로, 가급적 Corretto 17로 업그레이드하는 것이 좋습니다. Corretto 17 릴리스에는 최신 코드가 포함되어 있고 일반적으로 이전 버전보다 성능이 더 좋습니다. 경우에 따라 최신 JDK를 사용해야 할 수도 있습니다. 하지만 최신 JDK는 EOL 날짜가 가까운 단기 지원 릴리스일 수 있습니다. JavaFX 웹 사이트에서 JFX 릴리스를 찾아 다운로드할 수 있습니다.

Q: Corretto 8은 어떤 운영 체제를 지원하나요?

Corretto 8 설치 패키지는 Amazon에서 Linux(glibc), Linux(musl-libc), Windows 및 macOS용으로 배포됩니다.

Windows 빌드는 버전 10 이상, Server 2016, Server 2019, Server 2022에서 지원됩니다.

macOS 빌드는 모든 버전의 macOS에서 지원되며 여전히 Apple로부터 보안 패치를 받고 있습니다. 현재 지원되는 버전은 x64(Intel) 및 aarch64(M1) 아키텍처에서 12(Monterey) 이상입니다.

Linux(glibc) 빌드는 Red Hat Enterprise Linux 6 이상, CentOS 6 이상, Ubuntu Linux 14 이상, Debian Linux 8 이상, Amazon Linux AMI 및 SuSE 12 이상에서 지원됩니다.

Linux(musl-libc) 빌드는 Alpine Linux 3.16 이상에서 지원됩니다.

Q: Corretto 11은 어떤 운영 체제를 지원하나요?

Corretto 11 설치 패키지는 Amazon에서 Linux(glibc), Linux(musl-libc), Windows 및 macOS용으로 배포됩니다.

Windows 빌드는 버전 10 이상, Server 2016, Server 2019 및 Server 2022에서 지원됩니다.

macOS 빌드는 모든 버전의 macOS에서 지원되며 여전히 Apple로부터 보안 패치를 받고 있습니다. 현재 지원되는 버전은 x64(Intel) 및 aarch64(M1) 아키텍처에서 12(Monterey) 이상입니다.

Linux(glibc) 빌드는 Red Hat Enterprise Linux 6 이상, CentOS 6 이상, Ubuntu Linux 14 이상, Debian Linux 8 이상, Amazon Linux AMI 및 SuSE 12 이상에서 지원됩니다.

Linux(musl-libc) 빌드는 Alpine Linux 3.16 이상에서 지원됩니다.

Q: Corretto 17은 어떤 운영 체제를 지원하나요?

Corretto 17 설치 패키지는 Amazon에서 Linux(glibc), Linux(musl-libc), Windows 및 macOS용으로 배포됩니다.

Windows 빌드는 버전 10 이상, Server 2016, Server 2019 및 Server 2022에서 지원됩니다.

macOS 빌드는 모든 버전의 macOS에서 지원되며 여전히 Apple로부터 보안 패치를 받고 있습니다. 현재 지원되는 버전은 x64(Intel) 및 aarch64(M1) 아키텍처에서 12(Monterey) 이상입니다.

Linux(glibc) 빌드는 Red Hat Enterprise Linux 6 이상, CentOS 6 이상, Ubuntu Linux 14 이상, Debian Linux 8 이상, Amazon Linux AMI 및 SuSE 12 이상에서 지원됩니다.

Linux(musl-libc) 빌드는 Alpine Linux 3.16 이상에서 지원됩니다.

Q: Corretto 21은 어떤 운영 체제를 지원하나요?

Corretto 21 설치 패키지는 Amazon에서 Linux(glibc), Linux(musl-libc), Windows 및 macOS용으로 배포됩니다.

Windows 빌드는 버전 10 이상, Server 2016, Server 2019 및 Server 2022에서 지원됩니다.

macOS 빌드는 모든 버전의 macOS에서 지원되며 여전히 Apple로부터 보안 패치를 받고 있습니다. 현재 지원되는 버전은 x64(Intel) 및 aarch64(M1) 아키텍처에서 12(Monterey) 이상입니다.

Linux(glibc) 빌드는 Red Hat Enterprise Linux 6 이상, CentOS 6 이상, Ubuntu Linux 14 이상, Debian Linux 8 이상, Amazon Linux AMI 및 SuSE 12 이상에서 지원됩니다.

Linux(musl-libc) 빌드는 Alpine Linux 3.16 이상에서 지원됩니다.

Q: 보안 스캐너에서 도커 이미지에 CVE가 있는 것으로 표시되는 이유는 무엇인가요?

보안 스캐너가 Corretto 도커 이미지에 CVE가 포함되어 있다고 보고하는 경우, 가장 먼저 권장되는 조치는 이 이미지의 업데이트된 버전을 찾는 것입니다. 업데이트된 Corretto 도커 이미지는 이 사이트에서 제공됩니다.

업데이트된 이미지가 없는 경우 적절한 명령을 실행하여 플랫폼용 패키지를 업데이트합니다. 예를 들어 문제를 즉시 해결하려면 Dockerfile 또는 시스템에서 AmazonLinux의 경우 ‘yum update -y --security’, Alpine Linux의 경우 ‘apk -U upgrade’를 실행합니다.

업데이트된 패키지가 없는 경우, 이 문제를 잠재적인 보안 문제로 간주하고 [AWS 취약성 보고 지침]을 따르거나 aws-security@amazon.com으로 AWS Security 팀에 직접 이메일을 보내주시기 바랍니다.

이미지와 패키지에 대한 보안 업데이트를 시의적절하게 제공해야 할 책임은 기본 도커 이미지 공급업체에게 있습니다. AWS는 Amazon Linux용 기본 도커 이미지만 제공합니다. 이 이미지는 Docker Hub Amazon Linux 2 페이지 및 Amazon Linux 2 ECR 퍼블릭 갤러리에서 제공됩니다. Alpine 기반 도커 이미지는 Docker Hub Alpine Linux 페이지에서 제공됩니다.

Docker Hub는 새로운 기본 이미지가 제공될 경우 도커 이미지를 자동으로 재구축하지만, Corretto 팀은 일회성 패키지 업데이트를 가져오기 위해 Dockerfile을 변경하지 않습니다. 기본 도커 이미지 공급업체에서 새 기본 이미지를 아직 제공하지 않은 경우, 해당 공급업체에 문의하여 새 기본 도커 이미지 배포에서 수정 사항을 해결하도록 요청하세요.

여기에서 설명하듯이, CVE가 도커 이미지에 나타나는 데에는 여러 가지 이유가 있습니다.

라이선싱 및 오픈 소스

Q: Corretto의 라이선스 조건은 어떻게 되나요?

Corretto는 OpenJDK와 동일한 오픈 소스 라이선스로 출시되었습니다. OpenJDK는 클래스 경로 예외(CPE가 포함된 GPLv2)가 적용되는 GNU 라이선스 버전 2에 따라 라이선스가 부여됩니다. OpenJDK를 사용하는 것처럼 Corretto를 사용할 수 있습니다.

Q: Amazon은 OpenJDK에 어떻게 기여하고 있나요?

Amazon은 2017년부터 OpenJDK에 기여하기 시작했으며, 그 수와 복잡성 모두에서 기여도를 높일 계획입니다.

Q: Corretto에 기여하려면 어떻게 해야 하나요?

Amazon은 코드를 Corretto로 가져오는 방법으로 OpenJDK 프로젝트에 기여하도록 권장합니다. 이렇게 하면 OpenJDK 커뮤니티 전체가 변경 사항의 이점을 누릴 수 있습니다. 빌드 로직과 같이 Corretto에만 기여한 경우 GitHub에서 코드를 사용할 수 있습니다. GitHub에서는 문제를 평가하고 요청을 가져옵니다.

 

만료된 버전

Corretto 릴리스 릴리스 유형 GA 날짜 마지막으로 계획된 업데이트 지원 종료
15 FR 2020년 9월 24일 2021년 1월 19일 2021년 4월 20일
16 FR 2021년 3월 16일  2021년 7월 20일 2021년 10월 19일 
18 FR 2022년 3월 22일 2022년 7월 19일 2022년 10월 18일
19 FR 2022년 9월 20일 2023년 1월 17일 2023년 4월 19일
20 FR 2023년 3월 21일 2023년 7월 18일 2023년 10월 17일


FR: 기능 릴리스